Index: /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/boundary.f90
===================================================================
--- /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/boundary.f90	(revision 5212)
+++ /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/boundary.f90	(revision 5213)
@@ -927,8 +1082,6 @@
          END SELECT
       ENDIF
-
-      
+ 
    END SUBROUTINE boundary__get_seg_number 
-   !> @endcode
    !------------------------------------------------------------------- 
    !> @brief This subroutine get segment indices for one boundary.
@@ -937,14 +1090,13 @@
    ! 
    !> @author J.Paul 
-   !> - Nov, 2013- Initial Version 
-   ! 
-   !> @param[inout] td_bdy : boundary structure  
-   !> @param[in] td_var : variable structure  
-   !> @param[in] id_index : boundary orthogonal index  
-   !> @param[in] id_width : bounary width 
-   !> @param[in] id_first : boundary first indice
-   !> @param[in] id_last  : boundary last  indice
-   !------------------------------------------------------------------- 
-   !> @code 
+   !> @date November, 2013 - Initial Version 
+   ! 
+   !> @param[inout] td_bdy boundary structure  
+   !> @param[in] td_var    variable structure  
+   !> @param[in] id_index  boundary orthogonal index  
+   !> @param[in] id_width  bounary width 
+   !> @param[in] id_first  boundary first indice
+   !> @param[in] id_last   boundary last  indice
+   !------------------------------------------------------------------- 
    SUBROUTINE boundary__get_seg_indices( td_bdy, td_var, &
    &                                     id_index, id_width, id_first, id_last) 
@@ -1004,13 +1156,13 @@
       END SELECT
 
-      il_max(jp_north)=td_var%t_dim(1)%i_len-ig_ghost
-      il_max(jp_south)=td_var%t_dim(1)%i_len-ig_ghost
-      il_max(jp_east )=td_var%t_dim(2)%i_len-ig_ghost
-      il_max(jp_west )=td_var%t_dim(2)%i_len-ig_ghost
-
-      il_min(jp_north)=1+ig_ghost
-      il_min(jp_south)=1+ig_ghost
-      il_min(jp_east )=1+ig_ghost
-      il_min(jp_west )=1+ig_ghost
+      il_max(jp_north)=td_var%t_dim(1)%i_len-ip_ghost
+      il_max(jp_south)=td_var%t_dim(1)%i_len-ip_ghost
+      il_max(jp_east )=td_var%t_dim(2)%i_len-ip_ghost
+      il_max(jp_west )=td_var%t_dim(2)%i_len-ip_ghost
+
+      il_min(jp_north)=1+ip_ghost
+      il_min(jp_south)=1+ip_ghost
+      il_min(jp_east )=1+ip_ghost
+      il_min(jp_west )=1+ip_ghost
          
       ! special case for EW cyclic 
@@ -1074,4 +1226,5 @@
          CALL boundary__add_seg(td_bdy,tl_seg)
 
+         ! clean
          CALL seg__clean(tl_seg)
          
@@ -1081,5 +1234,4 @@
       
    END SUBROUTINE boundary__get_seg_indices 
-   !> @endcode
    !------------------------------------------------------------------- 
    !> @brief This subroutine check if there is boundary at corner, and 
@@ -1094,12 +1246,9 @@
    ! 
    !> @author J.Paul 
-   !> - Nov, 2013- Initial Version 
-   ! 
-   !> @param[inout] td_bdy : boundary structure
-   !> @param[in] td_var : variable structure
-   !> 
-   !> @todo add schematic to description
-   !------------------------------------------------------------------- 
-   !> @code 
+   !> @date November, 2013 - Initial Version 
+   ! 
+   !> @param[inout] td_bdy boundary structure
+   !> @param[in] td_var    variable structure
+   !------------------------------------------------------------------- 
    SUBROUTINE boundary_check_corner( td_bdy, td_var )
       IMPLICIT NONE 
@@ -1126,6 +1275,6 @@
       ! check north west corner
       IF( td_bdy(jp_north)%l_use .AND. td_bdy(jp_west)%l_use )THEN
-         tl_west =td_bdy(jp_west )%t_seg(td_bdy(jp_west)%i_nseg)
-         tl_north=td_bdy(jp_north)%t_seg(1)
+         tl_west =seg__copy(td_bdy(jp_west )%t_seg(td_bdy(jp_west)%i_nseg))
+         tl_north=seg__copy(td_bdy(jp_north)%t_seg(1))
 
          IF( tl_west%i_last  >= tl_north%i_index .AND. &
@@ -1148,6 +1297,6 @@
             ENDIF
 
-            td_bdy(jp_west )%t_seg(td_bdy(jp_west)%i_nseg)=tl_west
-            td_bdy(jp_north)%t_seg(1)                     =tl_north
+            td_bdy(jp_west )%t_seg(td_bdy(jp_west)%i_nseg)=seg__copy(tl_west)
+            td_bdy(jp_north)%t_seg(1)                     =seg__copy(tl_north)
 
          ELSE
@@ -1169,6 +1318,6 @@
       ! check north east corner
       IF( td_bdy(jp_north)%l_use .AND. td_bdy(jp_east)%l_use )THEN
-         tl_east =td_bdy(jp_east )%t_seg(td_bdy(jp_east )%i_nseg)
-         tl_north=td_bdy(jp_north)%t_seg(td_bdy(jp_north)%i_nseg)
+         tl_east =seg__copy(td_bdy(jp_east )%t_seg(td_bdy(jp_east )%i_nseg))
+         tl_north=seg__copy(td_bdy(jp_north)%t_seg(td_bdy(jp_north)%i_nseg))
 
          IF( tl_east%i_last  >= tl_north%i_index .AND. &
@@ -1191,6 +1340,6 @@
             ENDIF
 
-            td_bdy(jp_east )%t_seg(td_bdy(jp_east )%i_nseg)=tl_east
-            td_bdy(jp_north)%t_seg(td_bdy(jp_north)%i_nseg)=tl_north
+            td_bdy(jp_east )%t_seg(td_bdy(jp_east )%i_nseg)=seg__copy(tl_east)
+            td_bdy(jp_north)%t_seg(td_bdy(jp_north)%i_nseg)=seg__copy(tl_north)
          ELSE
 
@@ -1211,6 +1360,6 @@
       ! check south east corner
       IF( td_bdy(jp_south)%l_use .AND. td_bdy(jp_east)%l_use )THEN
-         tl_east =td_bdy(jp_east )%t_seg(1)
-         tl_south=td_bdy(jp_south)%t_seg(td_bdy(jp_south)%i_nseg)
+         tl_east =seg__copy(td_bdy(jp_east )%t_seg(1))
+         tl_south=seg__copy(td_bdy(jp_south)%t_seg(td_bdy(jp_south)%i_nseg))
 
          IF( tl_east%i_first <= tl_south%i_index .AND. &
@@ -1233,6 +1382,6 @@
             ENDIF
 
-            td_bdy(jp_east )%t_seg(1)                      =tl_east
-            td_bdy(jp_south)%t_seg(td_bdy(jp_south)%i_nseg)=tl_south
+            td_bdy(jp_east )%t_seg(1)                      =seg__copy(tl_east)
+            td_bdy(jp_south)%t_seg(td_bdy(jp_south)%i_nseg)=seg__copy(tl_south)
          ELSE
 
@@ -1253,6 +1402,6 @@
       ! check south west corner
       IF( td_bdy(jp_south)%l_use .AND. td_bdy(jp_west)%l_use )THEN
-         tl_west =td_bdy(jp_west )%t_seg(1)
-         tl_south=td_bdy(jp_south)%t_seg(1)
+         tl_west =seg__copy(td_bdy(jp_west )%t_seg(1))
+         tl_south=seg__copy(td_bdy(jp_south)%t_seg(1))
 
          IF( tl_west%i_first <= tl_south%i_index .AND. &
@@ -1275,6 +1424,6 @@
             ENDIF
 
-            td_bdy(jp_west )%t_seg(1) = tl_west
-            td_bdy(jp_south)%t_seg(1) = tl_south
+            td_bdy(jp_west )%t_seg(1) = seg__copy(tl_west)
+            td_bdy(jp_south)%t_seg(1) = seg__copy(tl_south)
          ELSE
 
@@ -1293,6 +1442,11 @@
       ENDIF
 
+      ! clean
+      CALL seg__clean(tl_north)
+      CALL seg__clean(tl_south)
+      CALL seg__clean(tl_east )
+      CALL seg__clean(tl_west )
+
    END SUBROUTINE boundary_check_corner 
-   !> @endcode
    !------------------------------------------------------------------- 
    !> @brief This subroutine check boundary.
@@ -1303,10 +1457,9 @@
    ! 
    !> @author J.Paul 
-   !> - Nov, 2013- Initial Version 
-   ! 
-   !> @param[inout] td_bdy : boundary structure 
-   !> @param[in] td_var : variable structure 
-   !------------------------------------------------------------------- 
-   !> @code 
+   !> @date November, 2013 - Initial Version 
+   ! 
+   !> @param[inout] td_bdy boundary structure 
+   !> @param[in] td_var    variable structure 
+   !------------------------------------------------------------------- 
    SUBROUTINE boundary_check(td_bdy, td_var) 
       IMPLICIT NONE 
@@ -1328,8 +1481,8 @@
       il_max(jp_west )=td_var%t_dim(2)%i_len
       
-      il_maxindex(jp_north)=td_var%t_dim(2)%i_len-ig_ghost
-      il_maxindex(jp_south)=td_var%t_dim(2)%i_len-ig_ghost
-      il_maxindex(jp_east )=td_var%t_dim(1)%i_len-ig_ghost
-      il_maxindex(jp_west )=td_var%t_dim(1)%i_len-ig_ghost
+      il_maxindex(jp_north)=td_var%t_dim(2)%i_len-ip_ghost
+      il_maxindex(jp_south)=td_var%t_dim(2)%i_len-ip_ghost
+      il_maxindex(jp_east )=td_var%t_dim(1)%i_len-ip_ghost
+      il_maxindex(jp_west )=td_var%t_dim(1)%i_len-ip_ghost
 
       DO jk=1,ip_ncard
@@ -1366,127 +1519,4 @@
 
    END SUBROUTINE boundary_check
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine clean interpolated boundary in variable structure.
-   !
-   !> @detail
-   !> interpolation could create more point than needed for boundary (depending
-   !> on refinement factor). This subroutine keep only useful point on variable
-   !> 
-   !> @note we use width define in first segment, cause every segment of a
-   !> boundary should have the same width 
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variable strucutre
-   !> @param[in   ] td_bdy : boundary strucutre
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE boundary_clean_interp( td_var, td_bdy )
-      IMPLICIT NONE
-      ! Argument
-      TYPE(TVAR), INTENT(INOUT) :: td_var
-      TYPE(TBDY), INTENT(IN   ) :: td_bdy
-
-      ! local variable
-      TYPE(TVAR)  :: tl_var
-
-      INTEGER(i4) :: il_imin
-      INTEGER(i4) :: il_imax
-      INTEGER(i4) :: il_jmin
-      INTEGER(i4) :: il_jmax
-
-      ! loop indices
-      !----------------------------------------------------------------
-
-      ! copy input variable
-      tl_var=td_var
-
-      DEALLOCATE(td_var%d_value)
-
-      SELECT CASE(TRIM(td_bdy%c_card))
-      CASE('north')
-
-         il_imin=1
-         il_imax=tl_var%t_dim(1)%i_len
-         SELECT CASE(td_var%c_point)
-         CASE('V','F')
-            il_jmin=td_bdy%t_seg(1)%i_width+1
-            il_jmax=2
-         CASE DEFAULT ! 'T','U'
-            il_jmin=td_bdy%t_seg(1)%i_width
-            il_jmax=1
-         END SELECT
-
-         ! use width as dimension length
-         td_var%t_dim(2)%i_len=td_bdy%t_seg(1)%i_width
-
-      CASE('south')
-
-         il_imin=1
-         il_imax=tl_var%t_dim(1)%i_len
-
-         il_jmin=1
-         il_jmax=td_bdy%t_seg(1)%i_width
-         
-         ! use width as dimension length
-         td_var%t_dim(2)%i_len=td_bdy%t_seg(1)%i_width
-
-      CASE('east')
-
-         SELECT CASE(td_var%c_point)
-         CASE('U','F')
-            il_imin=td_bdy%t_seg(1)%i_width+1
-            il_imax=2
-         CASE DEFAULT ! 'T','V'
-            il_imin=td_bdy%t_seg(1)%i_width
-            il_imax=1
-         END SELECT
-
-         il_jmin=1
-         il_jmax=tl_var%t_dim(2)%i_len
-
-         ! use width as dimension length
-         td_var%t_dim(1)%i_len=td_bdy%t_seg(1)%i_width
-
-      CASE('west')
-
-         il_imin=1
-         il_imax=td_bdy%t_seg(1)%i_width
-
-         il_jmin=1
-         il_jmax=tl_var%t_dim(2)%i_len
-
-         ! use width as dimension length
-         td_var%t_dim(1)%i_len=td_bdy%t_seg(1)%i_width
-
-      END SELECT
-
-
-      ALLOCATE( td_var%d_value(td_var%t_dim(1)%i_len, &
-      &                        td_var%t_dim(2)%i_len, &
-      &                        td_var%t_dim(3)%i_len, &
-      &                        td_var%t_dim(4)%i_len) )
-
-      IF( il_imin > il_imax )THEN
-         il_imin=tl_var%t_dim(1)%i_len-il_imin+1
-         il_imax=tl_var%t_dim(1)%i_len-il_imax+1
-      ENDIF
-
-      IF( il_jmin > il_jmax )THEN
-         il_jmin=tl_var%t_dim(2)%i_len-il_jmin+1
-         il_jmax=tl_var%t_dim(2)%i_len-il_jmax+1
-      ENDIF      
-
-      td_var%d_value(:,:,:,:)=tl_var%d_value( il_imin:il_imax, &
-      &                                       il_jmin:il_jmax, &
-      &                                       :,: )
-
-      CALL var_clean(tl_var)
-
-
-   END SUBROUTINE boundary_clean_interp
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine swap array for east and north boundary.
@@ -1495,10 +1525,9 @@
    !> 
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
+   !> @date November, 2013 - Initial Version
    !
-   !> @param[inout] td_var : variable strucutre
-   !> @param[in   ] td_bdy : boundary strucutre
+   !> @param[inout] td_var variable strucutre
+   !> @param[in   ] td_bdy boundary strucutre
    !-------------------------------------------------------------------
-   !> @code
    SUBROUTINE boundary_swap( td_var, td_bdy )
       IMPLICIT NONE
@@ -1516,5 +1545,5 @@
 
       IF( .NOT. ASSOCIATED(td_var%d_value) )THEN
-         CALL logger_error("BOUNDARY SWAP: no table of value "//&
+         CALL logger_error("BOUNDARY SWAP: no array of value "//&
          &  "associted to variable "//TRIM(td_var%c_name) )
       ELSE      
@@ -1555,16 +1584,12 @@
       ENDIF
    END SUBROUTINE boundary_swap
-   !> @endcode
-   !------------------------------------------------------------------- 
-   !> @brief This subroutine print information about one boundary 
-   ! 
-   !> @details 
+   !------------------------------------------------------------------- 
+   !> @brief This subroutine print information about one boundary. 
    ! 
    !> @author J.Paul 
-   !> - Nov, 2013- Initial Version 
-   ! 
-   !> @param[in] td_bdy : boundary structure 
-   !------------------------------------------------------------------- 
-   !> @code 
+   !> @date November, 2013 - Initial Version 
+   ! 
+   !> @param[in] td_bdy boundary structure 
+   !------------------------------------------------------------------- 
    SUBROUTINE boundary__print_unit( td_bdy ) 
       IMPLICIT NONE 
@@ -1588,17 +1613,15 @@
  
    END SUBROUTINE boundary__print_unit
-   !> @endcode
-   !------------------------------------------------------------------- 
-   !> @brief This subroutine print information about a table of boundary 
+   !------------------------------------------------------------------- 
+   !> @brief This subroutine print information about a array of boundary 
    ! 
    !> @details 
    ! 
    !> @author J.Paul 
-   !> - Nov, 2013- Initial Version 
-   ! 
-   !> @param[in] td_bdy : boundary structure 
-   !------------------------------------------------------------------- 
-   !> @code 
-   SUBROUTINE boundary__print_tab( td_bdy ) 
+   !> @date November, 2013 - Initial Version 
+   ! 
+   !> @param[in] td_bdy boundary structure 
+   !------------------------------------------------------------------- 
+   SUBROUTINE boundary__print_arr( td_bdy ) 
       IMPLICIT NONE 
       ! Argument
@@ -1613,27 +1636,30 @@
       ENDDO
  
-   END SUBROUTINE boundary__print_tab
-   !> @endcode
+   END SUBROUTINE boundary__print_arr
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine copy segment structure in another segment
-   !> structure
-   !> @details 
+   !> This subroutine copy segment structure in another one.
    !>
+   !> @warning do not use on the output of a function who create or read a
+   !> structure (ex: tl_seg=seg__copy(seg__init()) is forbidden).
+   !> This will create memory leaks.
    !> @warning to avoid infinite loop, do not use any function inside 
    !> this subroutine
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
+   !> @date November, 2013 - Initial Version
+   !> @date November, 2014
+   !>    - use function instead of overload assignment operator 
+   !> (to avoid memory leak)
    !
-   !> @param[out] td_seg1  : segment structure
-   !> @param[in] td_seg2  : segment structure
+   !> @param[in] td_seg   segment structure
+   !> @return copy of input segment structure
    !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE seg__copy( td_seg1, td_seg2 )
+   FUNCTION seg__copy_unit( td_seg )
       IMPLICIT NONE
       ! Argument
-      TYPE(TSEG), INTENT(OUT) :: td_seg1
-      TYPE(TSEG), INTENT(IN)  :: td_seg2
+      TYPE(TSEG), INTENT(IN)  :: td_seg
+      ! function
+      TYPE(TSEG) :: seg__copy_unit
 
       ! local variable
@@ -1642,11 +1668,46 @@
 
       ! copy segment index, width, ..
-      td_seg1%i_index    = td_seg2%i_index
-      td_seg1%i_width    = td_seg2%i_width
-      td_seg1%i_first    = td_seg2%i_first
-      td_seg1%i_last     = td_seg2%i_last 
-
-   END SUBROUTINE seg__copy
-   !> @endcode
+      seg__copy_unit%i_index    = td_seg%i_index
+      seg__copy_unit%i_width    = td_seg%i_width
+      seg__copy_unit%i_first    = td_seg%i_first
+      seg__copy_unit%i_last     = td_seg%i_last 
+
+   END FUNCTION seg__copy_unit
+   !-------------------------------------------------------------------
+   !> @brief
+   !> This subroutine copy segment structure in another one.
+   !>
+   !> @warning do not use on the output of a function who create or read a
+   !> structure (ex: tl_seg=seg__copy(seg__init()) is forbidden).
+   !> This will create memory leaks.   
+   !> @warning to avoid infinite loop, do not use any function inside 
+   !> this subroutine
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !> @date November, 2014
+   !>    - use function instead of overload assignment operator 
+   !> (to avoid memory leak)
+   !
+   !> @param[in] td_seg   segment structure
+   !> @return copy of input array of segment structure
+   !-------------------------------------------------------------------
+   FUNCTION seg__copy_arr( td_seg )
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TSEG), DIMENSION(:), INTENT(IN)  :: td_seg
+      ! function
+      TYPE(TSEG), DIMENSION(SIZE(td_seg(:))) :: seg__copy_arr
+
+      ! local variable
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+
+      DO ji=1,SIZE(td_seg(:))
+         seg__copy_arr(ji)=seg__copy(td_seg(ji))
+      ENDDO
+
+   END FUNCTION seg__copy_arr
    !------------------------------------------------------------------- 
    !> @brief This function  initialise segment structure.
@@ -1657,13 +1718,12 @@
    ! 
    !> @author J.Paul 
-   !> - Nov, 2013- Initial Version 
-   ! 
-   !> @param[in] id_index : orthogonal index
-   !> @param[in] id_width : width of the segment 
-   !> @param[in] id_first : first indices 
-   !> @param[in] id_last  : last  indices
+   !> @date November, 2013 - Initial Version 
+   ! 
+   !> @param[in] id_index  orthogonal index
+   !> @param[in] id_width  width of the segment 
+   !> @param[in] id_first  first indices 
+   !> @param[in] id_last   last  indices
    !> @return segment structure
    !------------------------------------------------------------------- 
-   !> @code 
    FUNCTION seg__init( id_index, id_width, id_first, id_last ) 
       IMPLICIT NONE 
@@ -1689,17 +1749,13 @@
 
    END FUNCTION seg__init 
-   !> @endcode
    !------------------------------------------------------------------- 
    !> @brief This subroutine clean segment structure. 
    ! 
-   !> @details 
-   ! 
    !> @author J.Paul 
-   !> - Nov, 2013- Initial Version 
-   ! 
-   !> @param[inout] td_seg : segment structure
-   !------------------------------------------------------------------- 
-   !> @code 
-   SUBROUTINE seg__clean(td_seg) 
+   !> @date November, 2013 - Initial Version 
+   ! 
+   !> @param[inout] td_seg segment structure
+   !------------------------------------------------------------------- 
+   SUBROUTINE seg__clean_unit(td_seg) 
       IMPLICIT NONE 
       ! Argument       
@@ -1710,48 +1766,28 @@
       !---------------------------------------------------------------- 
 
-      td_seg=tl_seg
+      td_seg=seg__copy(tl_seg)
  
-   END SUBROUTINE seg__clean 
-   !> @endcode
-!   !------------------------------------------------------------------- 
-!   !> @brief This function  
-!   ! 
-!   !> @details 
-!   ! 
-!   !> @author J.Paul 
-!   !> - Nov, 2013- Initial Version 
-!   ! 
-!   !> @param[in]  
-!   !------------------------------------------------------------------- 
-!   !> @code 
-!   FUNCTION boundary_() 
-!      IMPLICIT NONE 
-!      ! Argument       
-!      ! function 
-!      ! local variable 
-!      ! loop indices 
-!      !---------------------------------------------------------------- 
-! 
-!   END FUNCTION boundary_ 
-!   !> @endcode 
-!   !------------------------------------------------------------------- 
-!   !> @brief This subroutine  
-!   ! 
-!   !> @details 
-!   ! 
-!   !> @author J.Paul 
-!   !> - Nov, 2013- Initial Version 
-!   ! 
-!   !> @param[in]  
-!   !------------------------------------------------------------------- 
-!   !> @code 
-!   SUBROUTINE boundary_() 
-!      IMPLICIT NONE 
-!      ! Argument       
-!      ! local variable 
-!      ! loop indices 
-!      !---------------------------------------------------------------- 
-! 
-!   END SUBROUTINE boundary_ 
-!   !> @endcode
+   END SUBROUTINE seg__clean_unit
+   !------------------------------------------------------------------- 
+   !> @brief This subroutine clean segment structure. 
+   ! 
+   !> @author J.Paul 
+   !> @date November, 2013 - Initial Version 
+   ! 
+   !> @param[inout] td_seg array of segment structure
+   !------------------------------------------------------------------- 
+   SUBROUTINE seg__clean_arr(td_seg) 
+      IMPLICIT NONE 
+      ! Argument       
+      TYPE(TSEG), DIMENSION(:), INTENT(INOUT) :: td_seg
+      ! local variable 
+      ! loop indices 
+      INTEGER(i4) :: ji
+      !---------------------------------------------------------------- 
+
+      DO ji=SIZE(td_seg(:)),1,-1
+         CALL seg__clean(td_seg(ji))
+      ENDDO
+ 
+   END SUBROUTINE seg__clean_arr 
 END MODULE boundary
